Package: valh
Type: Package
Title: Interface Between R and the OpenStreetMap-Based Routing Service
        'Valhalla'
Version: 0.2.0
Authors@R: c(person("Timothée", "Giraud", email = "timothee.giraud@cnrs.fr",
    role = c("cre","aut"),  comment = c(ORCID = "0000-0002-1932-3323")),
    person("Matthieu", "Viry", role = c("aut"),
    comment = c(ORCID = "0000-0002-0693-8556")))
Description: An interface between R and the 'Valhalla' API. 'Valhalla' is a
    routing service based on 'OpenStreetMap' data.
    See <https://valhalla.github.io/valhalla/> for more information.
    This package enables the computation of routes, trips, isochrones and
    travel distances matrices (travel time and kilometer distance).
License: GPL (>= 3)
Imports: jsonlite, googlePolylines, curl, utils, sf
Depends: R (>= 3.5.0)
Suggests: knitr, rmarkdown, tinytest
URL: https://github.com/riatelab/valh
BugReports: https://github.com/riatelab/valh/issues
Encoding: UTF-8
RoxygenNote: 7.3.3
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2026-02-12 14:05:15 UTC; tim
Author: Timothée Giraud [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-1932-3323>),
  Matthieu Viry [aut] (ORCID: <https://orcid.org/0000-0002-0693-8556>)
Maintainer: Timothée Giraud <timothee.giraud@cnrs.fr>
Repository: CRAN
Date/Publication: 2026-02-12 14:20:02 UTC
Built: R 4.6.0; ; 2026-04-28 12:53:06 UTC; unix

Package: valh
Type: Package
Title: Interface Between R and the OpenStreetMap-Based Routing Service
        'Valhalla'
Version: 0.2.0
Authors@R: c(person("Timothée", "Giraud", email = "timothee.giraud@cnrs.fr",
    role = c("cre","aut"),  comment = c(ORCID = "0000-0002-1932-3323")),
    person("Matthieu", "Viry", role = c("aut"),
    comment = c(ORCID = "0000-0002-0693-8556")))
Description: An interface between R and the 'Valhalla' API. 'Valhalla' is a
    routing service based on 'OpenStreetMap' data.
    See <https://valhalla.github.io/valhalla/> for more information.
    This package enables the computation of routes, trips, isochrones and
    travel distances matrices (travel time and kilometer distance).
License: GPL (>= 3)
Imports: jsonlite, googlePolylines, curl, utils, sf
Depends: R (>= 3.5.0)
Suggests: knitr, rmarkdown, tinytest
URL: https://github.com/riatelab/valh
BugReports: https://github.com/riatelab/valh/issues
Encoding: UTF-8
RoxygenNote: 7.3.3
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2026-02-12 14:05:15 UTC; tim
Author: Timothée Giraud [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-1932-3323>),
  Matthieu Viry [aut] (ORCID: <https://orcid.org/0000-0002-0693-8556>)
Maintainer: Timothée Giraud <timothee.giraud@cnrs.fr>
Repository: CRAN
Date/Publication: 2026-02-12 14:20:02 UTC
Built: R 4.6.0; ; 2026-04-26 11:00:06 UTC; unix

# valh <img src="man/figures/logo.png" align="right" width="140"/>

[![CRAN](https://www.r-pkg.org/badges/version/valh)](https://CRAN.R-project.org/package=valh)
[![R build
status](https://github.com/riatelab/valh/actions/workflows/check-standard.yaml/badge.svg)](https://github.com/riatelab/valh/actions)
[![codecov](https://codecov.io/gh/riatelab/valh/graph/badge.svg)](https://app.codecov.io/gh/riatelab/valh)
[![Project Status: Active – The project has reached a stable, usable
state and is being actively
developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)

[Valhalla](https://valhalla.github.io/valhalla/) is a routing service
that is based on OpenStreetMap data. This package provides an interface
to the Valhalla API from R. It allows you to query the Valhalla API for
routes, isochrones, time-distance matrices, nearest point on the road
network, and elevation data.

This package relies on the usage of a [running Valhalla
server](https://github.com/riatelab/valh?tab=readme-ov-file#installing-your-own-valhalla-server)
(tested with versions 3.4.x, 3.5.x and 3.6.x of Valhalla).

<img src="man/figures/map.png" align="center" width="500"/>

[code for the
map](https://gist.github.com/rCarto/8dfba641b807c20c8cbf72ef8ed0c9c5)

## Features

- `vl_route()`: Get route between locations.
- `vl_matrix()`: Get travel time matrices between points.
- `vl_locate()`: Get the nearest point on the road network.
- `vl_elevation()`: Get elevation data at given location(s).
- `vl_isochrone()`: Get isochrone polygons.
- `vl_optimized_route()`: Get optimized route between locations.
- `vl_status()`: Get information on Valhalla service.

## Installation

- Stable version from CRAN:

``` r
install.packages("valh")
```

- Development version from the r-universe.

``` r
install.packages("valh", repos = "https://riatelab.r-universe.dev")
```

## Demo

This is a short overview of the main features of `valh`. The dataset
used here is shipped with the package, it is a sample of 100 random
pharmacies in Berlin ([© OpenStreetMap
contributors](https://www.openstreetmap.org/copyright/en)) stored in a
[geopackage](https://www.geopackage.org/) file.

It demonstrates the use of `vl_matrix`, `vl_route` and `vl_elevation`
functions.

``` r
library(valh)
```

    ## Data: (c) OpenStreetMap contributors, ODbL 1.0 - http://www.openstreetmap.org/copyright

    ## Routing: Valhalla - valhalla.github.io/valhalla

``` r
library(sf)
```

    ## Linking to GEOS 3.13.1, GDAL 3.10.3, PROJ 9.6.0; sf_use_s2() is TRUE

``` r
pharmacy <- st_read(system.file("gpkg/apotheke.gpkg", package = "valh"), quiet = TRUE)
pharmacy <- pharmacy[1:6, ]
```

One of valhalla’s strengths is that it allows you to use dynamic costing
options at query time. For example, we can compare the travel time
between each pharmacy by bicycle:

- with the default bicycle parameters (type of bicycle “hybrid” with an
  average speed of 18 km/h and a propensity to use roads, alongside
  other vehicles, of 0.5 out of 1 - the default value),
- with the road bicycle parameters (type of bicycle “road” with an
  average speed of 25 km/h and a propensity to use roads, alongside
  other vehicles, of 1 out of 1).

These costing options for each costing model (‘auto’, ‘bicycle’, etc.)
are documented in [Valhalla’s
documentation](https://valhalla.github.io/valhalla/api/turn-by-turn/api-reference/#costing-models).

``` r
default_bike <- vl_matrix(loc = pharmacy, costing = "bicycle")

road_bike <- vl_matrix(loc = pharmacy, costing = "bicycle",
                       costing_options = list(bicycle_type = "Road", use_roads = "1"))
```

The object returned by `vl_matrix` is a list with 4 elements:

- `sources`: origin point coordinates,
- `destinations`: destination point coordinates,
- `distances` : distance matrix between sources and destinations,
- `durations` : travel time matrix between sources and destinations.

``` r
default_bike$durations
```

    ##      1    2    3    4    5    6
    ## 1  0.0 45.8 76.9 35.7 17.7 32.4
    ## 2 46.5  0.0 86.7 29.5 42.7 75.4
    ## 3 72.9 88.3  0.0 62.2 59.1 76.2
    ## 4 33.0 29.6 62.0  0.0 20.7 55.8
    ## 5 18.8 44.3 61.3 23.2  0.0 35.4
    ## 6 32.2 75.5 75.7 60.4 34.6  0.0

``` r
road_bike$durations
```

    ##      1    2    3    4    5    6
    ## 1  0.0 33.1 51.5 25.2 13.2 21.8
    ## 2 33.1  0.0 61.3 21.6 30.2 51.9
    ## 3 50.1 62.8  0.0 43.6 41.5 53.3
    ## 4 23.5 21.9 43.4  0.0 15.5 38.8
    ## 5 12.6 31.2 42.3 15.7  0.0 23.9
    ## 6 20.6 51.8 51.7 40.3 23.7  0.0

We can see not only that travel times are different (which is to be
expected, given that we’ve changed the cyclist’s default speed), but
also that the path taken are different (as a consequence of the change
in preference for using roads rather than cycle paths).

``` r
default_bike$distances - road_bike$distances
```

    ##       1      2      3      4      5      6
    ## 1 0.000 -0.191  1.394  0.599  0.015  0.003
    ## 2 0.015  0.000 -0.002  0.007 -0.249  0.336
    ## 3 1.095 -0.228  0.000 -0.050  0.410  0.033
    ## 4 0.015 -0.188 -0.009  0.000 -0.260 -0.061
    ## 5 0.594 -0.170  0.420  0.599  0.000 -0.072
    ## 6 0.017 -0.167 -0.676  0.035  0.026  0.000

We now calculate a route between two points, by foot, using the
`vl_route` function and calculate the elevation profile of the returned
route, using the `vl_elevation` function.

``` r
p1 <- pharmacy[3, ]
p2 <- pharmacy[6, ]
route <- vl_route(p1, p2, costing = "pedestrian")
plot(st_geometry(route), main = "Route between 2 pharmacies")
plot(c(st_geometry(p1), st_geometry(p2)), pch = 21, cex = 2, add = TRUE)
```

![](man/figures/README-route-1.png)<!-- -->

``` r
# We transform the LineString to Point geometries
pts_route <- sf::st_cast(st_geometry(route), "POINT")

elev <- vl_elevation(loc = pts_route, sampling_dist = 100)
```

The object returned is an sf object with a point for each location where
the altitude has been sampled and with the attributes ‘distance’ (the
cumulative distance to the first point) and ‘height’ (the altitude).

We can use it to plot the elevation profile of the route.

``` r
plot(as.matrix(st_drop_geometry(elev)), type = "l", lwd = 2, ylim = c(20, 70), asp = 100,
     main = "Elevation Profile")
```

![](man/figures/README-elevation-1.png)<!-- -->

## Installing your own Valhalla server

`valh` uses the Valhalla demo server by default. The [Valhalla
documentation](https://valhalla.github.io/valhalla/#demo-server) states
that “usage of the demo server follows the usual fair-usage policy as
OSRM & Nominatim demo servers (somewhat enforced by [rate
limits](https://github.com/valhalla/valhalla/discussions/3373#discussioncomment-1644713))”.  
This means that if you want to use Valhalla for a large number of
requests, you will need to install it locally or on your own server.  
To that end, we have included a
[vignette](https://CRAN.R-project.org/package=valh/vignettes/install-valhalla.html)
showing how to install your own instance of Valhalla, either locally or
on a remote server, using Docker.

## Motivation & Alternatives

The package is designed to provide an easy-to-use interface to the
Valhalla routing service from R. Special care has been taken to support
multiple input formats, and the package treats `sf` objects as
first-class citizens in both input and output. Additionally, we have
tried to maintain a minimal number of dependencies.

This package offers an API that closely resembles that of the
[`osrm`](https://github.com/riatelab/osrm) package which provides an R
interface to the OSRM routing service.

Note that there are other packages that provide an interface to Valhalla
API from R :

- [valhallr](https://github.com/chris31415926535/valhallr/): This
  package is on CRAN. It provides access to some of Valhalla’s services
  (*height*, *locate* and *optimized route* are notably missing). It
  depends on a number of rather heavy packages and it does not allow
  `sf` objects as input.
- [rvalhalla](https://github.com/Robinlovelace/rvalhalla): This package
  is not on CRAN. Although it can provide access to several Valhalla
  services, it only makes it easy to use two of them (*route* and
  *sources_to_target*). It does not accept `sf` objects as input.

## Community Guidelines

One can contribute to the package through [pull
requests](https://github.com/riatelab/valh/pulls) and report issues or
ask questions [here](https://github.com/riatelab/valh/issues). See the
[CONTRIBUTING.md](https://github.com/riatelab/valh/blob/master/CONTRIBUTING.md)
file for detailed instructions.

if(demo_server){
  options(valh.server = valh.server)
  expect_silent(x <- vl_route(src = x_df[1, ], dst = x_df[2, ]))
  expect_inherits(x, "sf")
  expect_true(nrow(x) == 1)
  expect_identical(st_crs(x), st_crs(4326))
  expect_silent(y <- vl_route(src = x_sf[1, ], dst = x_sf[2, ],
                               costing = "bicycle",
                               costing_options = list(bicycle_type = "Road")))
  expect_inherits(y, "sf")
  expect_true(nrow(y) == 1)
  expect_identical(st_crs(y), st_crs(x_sf))
  expect_silent(z <- vl_route(loc = x_sf[1:5, ],
                              costing = "bicycle",
                              costing_options = list(bicycle_type = "Road")))
  expect_inherits(z, "sf")
  expect_true(nrow(z) == 1)
  expect_identical(st_crs(z), st_crs(x_sf))
}

if(demo_server){
  options(valh.server = valh.server)
  x <- vl_matrix(src = x_df[1:10, ], dst = x_df[11:20, ])
  expect_true(length(x)==4)
  expect_equal(dim(x$sources), c(10,2))
  expect_equal(dim(x$destinations), c(10,2))
  expect_equal(dim(x$durations), c(10,10))
  expect_equal(dim(x$distances), c(10,10))
  expect_silent(y <- vl_matrix(loc = x_sf[1:10,],
                               costing = "bicycle",
                               costing_options = list(bicycle_type = "Road")))
  expect_true(max(diag(y$durations)) == 0)
  expect_identical(row.names(y$durations), row.names(x_sf[1:10, ]))
}

if(demo_server){
  options(valh.server = valh.server)
  expect_silent(x <- vl_optimized_route(loc = x_sf[1:6, ]))
  expect_silent(y <- vl_optimized_route(loc = x_df[1:6, ],
                                        end_at_start = TRUE,
                                        costing = "bicycle",
                                        costing_options = list(bicycle_type = "Mountain")))
  expect_inherits(x$shape, "sf")
  expect_true(nrow(x$shape) == 5)
  expect_identical(st_crs(x$shape), st_crs(x_sf))
  expect_identical(names(x$summary), c("duration", "distance", "has_toll",
                                       "has_highway", "has_time_restrictions",
                                       "has_ferry"))

  expect_inherits(y$shape, "sf")
  expect_true(nrow(y$shape) == 6)
  expect_identical(st_crs(y$shape), st_crs(4326))
  expect_identical(names(y$summary), c("duration", "distance", "has_toll",
                                       "has_highway", "has_time_restrictions",
                                       "has_ferry"))
}

# Single input/output
# incorrect vector
expect_error(valh:::input_route(x = c(35,"35"),
                                id = "src",
                                single = TRUE,
                                all.ids = FALSE))
expect_error(valh:::input_route(x = c(200,350),
                                id = "src",
                                single = TRUE,
                                all.ids = FALSE))
# multiline object
expect_message(valh:::input_route(x = x_sfc,
                                  id = "src",
                                  single = TRUE,
                                  all.ids = FALSE))
expect_message(valh:::input_route(x = x_df,
                                  id = "src",
                                  single = TRUE,
                                  all.ids = FALSE))
# x not a point
expect_error(valh:::input_route(x = st_cast(x_sf[1,], "MULTIPOINT"),
                                id = "src",
                                single = TRUE,
                                all.ids = FALSE))
# incorrect df
expect_error(valh:::input_route(x = st_drop_geometry(x_sf[1,]),
                                id = "src",
                                single = TRUE,
                                all.ids = FALSE))
# wrong input type
expect_error(valh:::input_route(x = st_crs(x_sf),
                                id = "src",
                                single = TRUE,
                                all.ids = FALSE))

# Multi input/output
# too short input
expect_error(valh:::input_route(x = x_sf[1,],
                                id = "loc",
                                single = FALSE,
                                all.ids = FALSE))
expect_error(valh:::input_route(x = x_df[1,,drop = FALSE],
                                id = "loc",
                                single = FALSE,
                                all.ids = FALSE))

# x not a point
expect_error(valh:::input_route(x = st_cast(x_sf[1:2,], "MULTIPOINT"),
                                id = "loc",
                                single = FALSE,
                                all.ids = FALSE))

# incorrect df
expect_error(valh:::input_route(x = st_drop_geometry(x_sf[1:2,]),
                                id = "loc",
                                single = FALSE,
                                all.ids = FALSE))
# wrong input type
expect_error(valh:::input_route(x = st_crs(x_sf),
                                id = "loc",
                                single = FALSE,
                                all.ids = FALSE))



######## SINGLE
# input vector
# input_route_out_v <- valh:::input_route(x = x_v,
#                                         id = "src",
#                                         single = TRUE,
#                                         all.ids = FALSE)
# saveRDS(input_route_out_v, "inst/tinytest/input_route_out_v.rds")
expect_identical(valh:::input_route(x = x_v,
                                    id = "src",
                                    single = TRUE,
                                    all.ids = FALSE),
                 readRDS("input_route_out_v.rds"))

# input data.frame
# input_route_out_df <- valh:::input_route(x = x_df[1,],
#                                         id = "src",
#                                         single = TRUE,
#                                         all.ids = FALSE)
# saveRDS(input_route_out_df, "inst/tinytest/input_route_out_df.rds")
expect_identical(valh:::input_route(x = x_df[1, ],
                                    id = "src",
                                    single = TRUE,
                                    all.ids = FALSE),
                 readRDS("input_route_out_df.rds"))

# input matrix
# input_route_out_m <- valh:::input_route(x = x_m[1,,drop = F],
#                                         id = "src",
#                                         single = TRUE,
#                                         all.ids = FALSE)
# saveRDS(input_route_out_m, "inst/tinytest/input_route_out_m.rds")
expect_identical(valh:::input_route(x =  x_m[1,,drop = F],
                                    id = "src",
                                    single = TRUE,
                                    all.ids = FALSE),
                 readRDS("input_route_out_m.rds"))

# input sfc
# input_route_out_sfc <- valh:::input_route(x = x_sfc[1],
#                                         id = "src",
#                                         single = TRUE,
#                                         all.ids = FALSE)
# saveRDS(input_route_out_sfc, "inst/tinytest/input_route_out_sfc.rds")
target <- readRDS("input_route_out_sfc.rds")
expect_silent(current <- valh:::input_route(x = x_sfc[1], id = "src", single = TRUE, all.ids = FALSE))
expect_identical(current$lon, target$lon)
expect_identical(current$oprj$input, target$oprj$input)

# input sf
# input_route_out_sf <- valh:::input_route(x = x_sf[1,],
#                                         id = "src",
#                                         single = TRUE,
#                                         all.ids = FALSE)
# saveRDS(input_route_out_sf, "inst/tinytest/input_route_out_sf.rds")
target <- readRDS("input_route_out_sf.rds")
expect_silent(current <- valh:::input_route(x = x_sf[1, ], id = "src", single = TRUE, all.ids = FALSE))
expect_identical(current$lon, target$lon)
expect_identical(current$oprj$input, target$oprj$input)


######## MULTI
# input data.frame
# input_route_out_df_m <- valh:::input_route(x = x_df[1:4,],
#                                         id = "loc",
#                                         single = FALSE,
#                                         all.ids = FALSE)
# saveRDS(input_route_out_df_m, "inst/tinytest/input_route_out_df_m.rds")
expect_identical(valh:::input_route(x = x_df[1:4, ],
                                    id = "loc",
                                    single = FALSE,
                                    all.ids = FALSE),
                 readRDS("input_route_out_df_m.rds"))

# input matrix
# input_route_out_m_m <- valh:::input_route(x = x_m[1:4,],
#                                         id = "src",
#                                         single = FALSE,
#                                         all.ids = FALSE)
# saveRDS(input_route_out_m_m, "inst/tinytest/input_route_out_m_m.rds")
expect_identical(valh:::input_route(x =  x_m[1:4,],
                                    id = "loc",
                                    single = FALSE,
                                    all.ids = FALSE),
                 readRDS("input_route_out_m_m.rds"))

# input sfc
# input_route_out_sfc_m <- valh:::input_route(x = x_sfc[1:4],
#                                         id = "loc",
#                                         single = FALSE,
#                                         all.ids = FALSE)
# saveRDS(input_route_out_sfc_m, "inst/tinytest/input_route_out_sfc_m.rds")
target <- readRDS("input_route_out_sfc_m.rds")
expect_silent(current <- valh:::input_route(x = x_sfc[1:4], id = "src", single = FALSE, all.ids = FALSE))
expect_identical(current$lon, target$lon)
expect_identical(current$oprj$input, target$oprj$input)




# input sf
# input_route_out_sf_m <- valh:::input_route(x = x_sf[1:4,],
#                                         id = "loc",
#                                         single = FALSE,
#                                         all.ids = FALSE)
# saveRDS(input_route_out_sf_m, "inst/tinytest/input_route_out_sf_m.rds")
target <- readRDS("input_route_out_sf_m.rds")
expect_silent(current <- valh:::input_route(x = x_sf[1:4, ], id = "src", single = FALSE, all.ids = FALSE))
expect_identical(current$lon, target$lon)
expect_identical(current$oprj$input, target$oprj$input)



######## MULTI + all.ids
# input data.frame
# input_route_out_df_m_id <- valh:::input_route(x = x_df[1:4,],
#                                         id = "loc",
#                                         single = FALSE,
#                                         all.ids = TRUE)
# saveRDS(input_route_out_df_m_id, "inst/tinytest/input_route_out_df_m_id.rds")
expect_identical(valh:::input_route(x = x_df[1:4, ],
                                    id = "loc",
                                    single = FALSE,
                                    all.ids = TRUE),
                 readRDS("input_route_out_df_m_id.rds"))

# input matrix
# input_route_out_m_m_id <- valh:::input_route(x = x_m[1:4,],
#                                         id = "src",
#                                         single = FALSE,
#                                         all.ids = TRUE)
# saveRDS(input_route_out_m_m_id, "inst/tinytest/input_route_out_m_m_id.rds")
expect_identical(valh:::input_route(x =  x_m[1:4,],
                                    id = "loc",
                                    single = FALSE,
                                    all.ids = TRUE),
                 readRDS("input_route_out_m_m_id.rds"))

# input sfc
# input_route_out_sfc_m_id <- valh:::input_route(x = x_sfc[1:4],
#                                         id = "loc",
#                                         single = FALSE,
#                                         all.ids = TRUE)
# saveRDS(input_route_out_sfc_m_id, "inst/tinytest/input_route_out_sfc_m_id.rds")
target <- readRDS("input_route_out_sfc_m_id.rds")
expect_silent(current <- valh:::input_route(x = x_sfc[1:4], id = "loc", single = FALSE, all.ids = TRUE))
expect_identical(current$lon, target$lon)
expect_identical(current$oprj$input, target$oprj$input)


# input sf
# input_route_out_sf_m_id <- valh:::input_route(x = x_sf[1:4,],
#                                         id = "loc",
#                                         single = FALSE,
#                                         all.ids = TRUE)
# saveRDS(input_route_out_sf_m_id, "inst/tinytest/input_route_out_sf_m_id.rds")
target <- readRDS("input_route_out_sf_m_id.rds")
expect_silent(current <- valh:::input_route(x = x_sf[1:4, ], id = "loc", single = FALSE, all.ids = TRUE))
expect_identical(current$lon, target$lon)
expect_identical(current$oprj$input, target$oprj$input)

# vector
expect_error(valh:::input_locate(x = c(35,"35")))
expect_error(valh:::input_locate(x = c(35, 35, 35)))
expect_error(valh:::input_locate(x = c(35, 195)))
# input_locate_out_v <- valh:::input_locate(x = x_v)
# saveRDS(input_locate_out_v, "inst/tinytest/input_locate_out_v.rds")
expect_identical(valh:::input_locate(x = x_v), readRDS("input_locate_out_v.rds"))

# geom
expect_error(valh:::input_locate(x = x_sfc_l))
# input_locate_out <- valh:::input_locate(x = x_sfc)
# saveRDS(input_locate_out, "inst/tinytest/input_locate_out_sfc.rds")
expect_silent(current <- valh:::input_locate(x = x_sfc))
target <- readRDS("input_locate_out_sfc.rds")
expect_identical(current$lon, target$lon)
expect_identical(current$oprj$input, target$oprj$input)
# input_locate_out <- valh:::input_locate(x = x_sf)
# saveRDS(input_locate_out, "inst/tinytest/input_locate_out_sf.rds")
expect_silent(current <- valh:::input_locate(x = x_sf))
target <- readRDS("input_locate_out_sf.rds")
expect_identical(current$lon, target$lon)
expect_identical(current$oprj$input, target$oprj$input)

# data.frame
er_x_df <- x_df
er_x_df[1, 2] <- "A"
expect_error(valh:::input_locate(er_x_df))
# input_locate_out <- valh:::input_locate(x = x_df)
# saveRDS(input_locate_out, "inst/tinytest/input_locate_out_df.rds")
expect_identical(valh:::input_locate(x = x_df), readRDS("input_locate_out_df.rds"))

# matrix
er_x_m <- x_m
er_x_m[1, 2] <- "A"
expect_error(input_locate(er_x_m))
# input_locate_out <- valh:::input_locate(x = x_m)
# saveRDS(input_locate_out, "inst/tinytest/input_locate_out_m.rds")
expect_identical(valh:::input_locate(x = x_m), readRDS("input_locate_out_m.rds"))

# else
expect_error(valh:::input_locate(plot))

if(demo_server){
  options(valh.server = valh.server)
  loc <- vl_elevation(x_v)
  expect_inherits(loc, "sf")
  loc <- vl_elevation(x_sfc[1])
  expect_inherits(loc, "sf")
  expect_identical(st_crs(loc), st_crs(x_sfc))

  loc <- vl_elevation(x_sf[1:10, ])
  expect_inherits(loc, "sf")
  expect_true(nrow(loc)==10)
  expect_identical(st_crs(loc), st_crs(x_sf))

  loc <- vl_elevation(x_df[1:10, ])
  expect_inherits(loc, "sf")
  expect_true(nrow(loc)==10)
  expect_inherits(loc, "sf")
  expect_identical(st_crs(loc), st_crs(4326))

  loc <- vl_elevation(x_sf[1:2, ], sampling_dist = 500)
  expect_inherits(loc, "sf")
  expect_true(nrow(loc)==21)
}

# geom
expect_error(valh:::input_table(x = x_sfc_l, "loc"))
# input_table_out <- valh:::input_table(x = x_sfc, "loc")
# saveRDS(input_table_out, "inst/tinytest/input_table_out_sfc.rds")
expect_identical(valh:::input_table(x = x_sfc, "loc"), readRDS("input_table_out_sfc.rds"))
# input_table_out <- valh:::input_table(x = x_sf, "loc")
# saveRDS(input_table_out, "inst/tinytest/input_table_out_sf.rds")
expect_identical(valh:::input_table(x = x_sf, "loc"), readRDS("input_table_out_sf.rds"))

# data.frame
er_x_df <- x_df
er_x_df[1, 2] <- "A"
expect_error(valh:::input_table(er_x_df, "loc"))
# input_table_out <- valh:::input_table(x = x_df, "loc")
# saveRDS(input_table_out, "inst/tinytest/input_table_out_df.rds")
expect_identical(valh:::input_table(x = x_df, "loc"), readRDS("input_table_out_df.rds"))

# matrix
er_x_m <- x_m
er_x_m[1, 2] <- "A"
expect_error(input_table(er_x_m, "loc"))
# input_table_out <- valh:::input_table(x = x_m, "loc")
# saveRDS(input_table_out, "inst/tinytest/input_table_out_m.rds")
expect_identical(valh:::input_table(x = x_m, "loc"), readRDS("input_table_out_m.rds"))

# else
expect_error(valh:::input_table(plot, "loc"))

if(demo_server){
  options(valh.server = valh.server)
  status <- vl_status(verbose = FALSE)
  expect_equal(length(status), 3)
  expect_equal(names(status), c("version", "tileset_last_modified", "available_actions"))
  status_v <- vl_status(verbose = TRUE)
  expect_true(length(status_v) >= 3)
}

# base_url
address_1 <- "https://valhalla1.openstreetmap.de/"
address_2 <- "https://valhalla1.openstreetmap.de"
address_3 <- "htps/valhalla1.openstreetmap.de/"

expect_identical(valh:::base_url(address_1), address_1)
expect_identical(valh:::base_url(address_2), address_1)
expect_error(valh:::base_url(address_3))

# clean_coord
expect_identical(valh:::clean_coord(45.123456789), "45.12346")

if(demo_server){
  options(valh.server = valh.server)
  loc <- vl_locate(x_v, costing = "bicycle", costing_options = list(cycling_speed = 190, bicycle_type = "road"))
  expect_inherits(loc, "sf")
  loc <- vl_locate(x_sfc[1])
  expect_inherits(loc, "sf")
  expect_identical(st_crs(loc), st_crs(x_sfc))

  loc <- vl_locate(x_sf[1:10, ])
  expect_inherits(loc, "list")
  expect_true(length(loc)==10)
  expect_inherits(loc[[1]], "sf")
  expect_identical(st_crs(loc[[1]]), st_crs(x_sf))

  loc <- vl_locate(x_df[1:10, ])
  expect_inherits(loc, "list")
  expect_true(length(loc)==10)
  expect_inherits(loc[[1]], "sf")
  expect_identical(st_crs(loc[[1]]), st_crs(4326))
}

if(demo_server){
  options(valh.server = valh.server)
  expect_error(vl_isochrone(x_v))
  expect_error(vl_isochrone(x_v, times = c(0,15,20,30)))
  expect_error(vl_isochrone(x_v, times = c(15,20,30,40,50)))
  expect_error(vl_isochrone(x_v, distances = c(0, 15,20,30)))
  expect_error(vl_isochrone(x_v, distances = c(15,20,30,40,50)))
  expect_error(vl_isochrone(x_v, times = c(15,20,30), distances = c(15,20,30)))
  expect_silent(x <- vl_isochrone(x_v,times = c(10,15,20,25),
                                  costing = "bicycle",
                                  costing_options = list(bicycle_type = "Road")))
  expect_inherits(x, "sf")
  expect_true(nrow(x)==4)

  x <- vl_isochrone(x_sf[1,], distances = c(15,20,30,40))
  expect_inherits(x, "sf")
  expect_true(nrow(x)==4)
  expect_identical(st_crs(x), st_crs(x_sf))

}

---
title: "Installing Valhalla with Docker"
author: "Matthieu Viry and Timothée Giraud"
date: "`r Sys.Date()`"
output:
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 1
    number_sections: true
vignette: >
  %\VignetteIndexEntry{Installing Valhalla with Docker}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

## Introduction

Valhalla is an open-source routing engine that uses OpenStreetMap data to provide
routing services. A demo server that is open to the public and includes a full planet
graph is available at [https://valhalla.openstreetmap.de](https://valhalla.openstreetmap.de).

However, the valhalla documentation states that *"usage of the demo server follows the usual
fair-usage policy as OSRM & Nominatim demo servers"*
([source](https://valhalla.github.io/valhalla/#demo-server)) and that this is enforced by
a rate limit of "*1 call/user/sec and 100 calls/sec total*"
([source](https://github.com/valhalla/valhalla/discussions/3373#discussioncomment-1644713)).

This means that if you want to use Valhalla for a large number of requests, you will need to
install it locally or on your own server.

Valhalla is a C++ application that can be compiled on most of modern platform and architectures,
but this can be challenging if you're not familiar with development tools and the command line.
The easiest way to install Valhalla is to use [Docker](https://docs.docker.com/), which allows
you to run Valhalla in a container without having to install it on your machine.


## Prerequisites

To follow this vignette, you need to have Docker installed and running on your machine or server
as well as a terminal to run the commands.
The commands in this vignette should work on any operating system (Linux, MacOS, Windows).

The installation of Docker is not covered here, but you can find the instructions on the official
Docker website:
[https://docs.docker.com/get-started/get-docker/](https://docs.docker.com/get-started/get-docker/).
To ensure that Docker is installed correctly, you can run the following command in your terminal:

```bash
docker run hello-world
```

If Docker is installed correctly you should see a message saying "Hello from Docker!".

## Valhalla installation

[Official Docker images](https://github.com/orgs/valhalla/packages) are provided by Valhalla team.
The one named "valhalla-scripted" features many options particularly useful for
customizing the Valhalla instance to be created (see its
[documentation](https://github.com/valhalla/valhalla/tree/master/docker) if needed)
and it's therefore the one we use here.

### Downloading an OSM extract

The first thing you need is an OpenStreetMap file, in osm.pbf format, of the region you want
to work on.

You can download an extract of the OSM data from [Geofabrik](https://download.geofabrik.de/)
or [BBBike](https://extract.bbbike.org/).
Planet files are available on [https://planet.openstreetmap.org/](https://planet.openstreetmap.org/),
but they are very large and not recommended for local use (as they would require a lot of memory).

Create a folder in which to store this file, here we'll call it `routing-valhalla` (use
`mkdir routing-valhalla` in your terminal to create it).
Then, download the OSM extract and move it to this folder.

### Running the Docker container

To run the Docker container, you need to run the following command in your terminal (you need
to be in the parent folder of the `routing-valhalla` folder you created earlier, or else you
will need to adapt the path to the folder):

```bash
docker run -t --name valhalla_server \
    -e build_elevation=True \
    -p 8002:8002 \
    -v $PWD/routing-valhalla:/custom_files \
    ghcr.io/valhalla/valhalla-scripted:latest
```

Here we are using:

- the `-t` option to run the container in interactive mode,
- the `--name` option to name the container `valhalla_server`,
- the `-p` option to publish the container's port 8002 to the host's port 8002,
- the `-v` option to mount the folder we created earlier (`routing-valhalla`)
  to the `/custom_files` folder in the container,
- `ghcr.io/valhalla/valhalla-scripted:latest` image to run the container.

and more importantly,

- the `-e` option to set the environment variable `build_elevation` to `True`,
  which builds the elevation data for the region.

Other useful options are listed on the
[image's README file](https://github.com/valhalla/valhalla/tree/master/docker#environment-variables).

These include :
- `build_elevation` to download and build elevation data (default: `False`), this is particularly
  useful for bicycle and pedestrian routing,
- `build_admins` to build administrative boundaries (default: `True`), this is useful for applying
  border-crossing penalties,
- `build_time_zones` to build timezone data (default: `True`), this is useful for time-dependent
  routing.

Once the graph is built, you should see a message like this:

```bash
INFO: Found config file. Starting valhalla service!
```

Note that this message is often followed by a several other messages, such as:

```bash
[INFO] Tile extract successfully loaded with tile count: 166
[WARN] (stat): /custom_files/traffic.tar No such file or directory
[WARN] Traffic tile extract could not be loaded
```

This is normal, as we did not provide traffic data to the container (and as traffic data are
loaded when the server is started).

You can now access the Valhalla API at `http://localhost:8002/` (replace `localhost`
by the IP address of your server if you are running it on a remote server).
Go to `http://localhost:8002/status` in your browser to check that the server is running).

### Interacting with the container

To stop the container, you can kill the process running in the terminal (using `Ctrl+C`), or
you can run the following command in another terminal:

```bash
docker stop valhalla_server
```

To restart the container, you can run the following command in your terminal:

```bash
docker start valhalla_server
```

This time the server starts instantly, as the graph has already been built, and the container
will run in the background (in detached mode). If needed you can check the logs of the container with:

```bash
docker logs valhalla_server
```

Finally, to totally get rid of the container and the image, you can run the following commands:

```bash
docker rm valhalla_server
docker rmi ghcr.io/valhalla/valhalla-scripted:latest
```

## Using Valhalla with R

To use your custom Valhalla instance with R and the `valh` package, you just need to change the
`valh.server` option to the url of your server or your machine :

```r
options(valh.server = "http://localhost:8002/")
```

You can also set this option in your `.Rprofile` file to make it permanent.

You're now ready to use `valh` with your own Valhalla installation!
